# $Id: storage.py 39 2007-05-11 14:41:08Z jcea $

import sys,os.path
directorio=os.path.split(sys.modules["storage"].__file__)[0]
sys.path.append(os.path.join(directorio,"durus-berkeleydbstorage"))

# Para poder acceder a los objetos desde el exterior
# del sistema, por si las moscas, utilizamos un "storage"
# de persistencia con acceso via unix socket

def storage(path) :
  if os.name != 'nt' : # De momento mi libreria no va en Windows...
    import berkeleydb_storage
    st=berkeleydb_storage.BerkeleyDBStorage(path,do_recover=True,durable=False,async_log_write=True)
  else :
    print >>sys.stderr,"ATENCION: Usando el backend durus normal..."
    from durus.file_storage import FileStorage
    st=FileStorage(os.path.join(path,"db.durus"))

  def storage_background(storage,path) :
    from durus.storage_server import StorageServer
    try :
      StorageServer(storage, address=path).serve()
    except SystemExit :
      import traceback
      traceback.print_exc()
      import os
      os._exit(os.EX_OK)

  def conn_constructor() :
    from durus.client_storage import ClientStorage
    from durus.connection import Connection

    conn= Connection(ClientStorage(address=path))
    return conn

  if os.name == 'nt' :
    path=("127.0.0.1",7911)  # En windows no hay sockets unix...

    def storage_background(storage,path) :
      storage_background.storage=storage
      storage_background.isAlive=lambda : True

    def conn_constructor() :
      from durus.connection import Connection
      conn=Connection(storage_background.storage)
      storage_background.storage=None # En esta modalidad, solo permitimos una conexion
      return conn
    
    storage_background(st,path)
    return storage_background,conn_constructor
  else :
    path=os.path.join(path,"unix_socket")

    import threading
    storage_thread=threading.Thread(target=storage_background,args=(st,path))
    storage_thread.setDaemon(True)
    storage_thread.start()

  return storage_thread,conn_constructor

def storage_test(path) :
  import os,os.path
  for i in os.listdir(path) :
    if i[0]=="." : continue
    os.remove(os.path.join(path,i))

  return storage(path)

def storage_and_monitor(path,storage=storage) :
  thread,constructor=storage(path)
  import monitor,time
  while thread.isAlive() :
    try :
      m=monitor.monitor(constructor)
      return thread,constructor,m
    except :
      time.sleep(0.1)

