# $Id: calendario.py 257 2007-07-10 22:50:38Z heimy $

cache_meses={}
nombres_meses=["","enero","febrero","marzo","abril","mayo","junio",
               "julio","agosto","septiembre","octubre","noviembre","diciembre"]
cabecera_mes="""<table>
 <tr><th colspan="7">%(prev_year)s %(prev_month)s %(month_name)s %(current_year)d %(next_month)s %(next_year)s</th></tr>
 <tr><th>L</th><th>M</th><th>X</th><th>J</th><th>V</th><th>S</th><th>D</th></tr>"""

def vista_mensual(conn,fecha,usuario,metatag) :
  from url_indice import fecha_min
  import calendar, datetime

  orig_date = fecha.replace(day = 1)
  month=fecha.month
  fecha=(fecha.year,month)
  mes=cache_meses.get(fecha)
  if not mes :
    mes=calendar.Calendar().monthdatescalendar(*fecha)
    date_number = fecha[0] * 100 + month
    today = datetime.date.today()
    yearmon_min = fecha_min.replace(day = 1)
    yearmon_max = today.replace(day = 1)
    delta_1, delta_32 = datetime.timedelta(1), datetime.timedelta(32)
    prev_m, next_m = (orig_date - delta_1,
                      (orig_date + delta_32).replace(day = 1))
    prev_y, next_y = ((datetime.date(fecha[0] - 1, month, 1) + delta_32).replace(day = 1) - delta_1,
                      datetime.date(fecha[0] + 1, month, 1))
    fecha_str = lambda x: "%04d%02d%02d" % (x.year, x.month, x.day)
    data = {
      "month_name": nombres_meses[fecha[1]].capitalize(),
      "current_year": fecha[0],
      }
    prev_year_text = '<a href="/indice/%%(metatag)d/%s">&#171;</a>' % fecha_str(prev_y)
    prev_month_text = '<a href="/indice/%%(metatag)d/%s">&lsaquo;</a>' % fecha_str(prev_m)
    next_month_text = '<a href="/indice/%%(metatag)d/%s">&rsaquo;</a>' % fecha_str(next_m)
    next_year_text = '<a href="/indice/%%(metatag)d/%s">&#187;</a>' % fecha_str(next_y)

    if yearmon_min > prev_y:
        data.update({ 'prev_year':   "&#171;",
                      'prev_month': (prev_month_text
                                     if yearmon_min < orig_date
                                     else "&lsaquo;") })
    else:
        data.update({ 'prev_month': prev_month_text,
                      'prev_year': ("&#171;"
                                    if yearmon_min.month > prev_y.month
                                    else prev_year_text) })
    if yearmon_max < next_y:
        data.update({ 'next_year':   "&#187;",
                      'next_month': ("&rsaquo;"
                                     if yearmon_max <= orig_date
                                     else next_month_text) })
    else:
        data.update({ 'next_month': next_month_text,
                      'next_year': ("&#187;"
                                    if yearmon_max.month > next_y.month
                                    else next_year_text) })
    
    texto=[cabecera_mes % data]
    while len(mes) :
      texto.append("<tr>")
      semana=mes.pop(0)
      for i in xrange(7) :
        dia=semana.pop(0)
        style=' class="nomonth"' if dia.month!=month else ''
        texto.append('<td align="center"%s><a href="/indice/%%(metatag)d/%d%.2d%.2d">%s</a></td>'
                       %(style,dia.year,dia.month,dia.day,dia.day))
      texto.append("</tr>\r\n")
    texto.append("</table>")
    mes="".join(texto)
    cache_meses[fecha]=mes
  return mes %{"metatag":metatag}

def daydate(ts,tz) :
  import datetime
  dt=datetime.datetime.fromtimestamp(ts,tz)
  return "%d de %s de %d" %(dt.day,nombres_meses[dt.month],dt.year)

def hourdate(ts,tz) :
  import datetime
  dt=datetime.datetime.fromtimestamp(ts,tz)
  return "%d de %s de %d, a las %.2d:%.2d" %(dt.day,nombres_meses[dt.month],dt.year,dt.hour,dt.minute)

