# $Id: parser_bbcode.py 472 2007-11-08 22:55:21Z alvaro $

# TODO: Deal with code context

import re

tags = {
        'b': ['b','b'],
        'i': ['i','i'],
        's': ['s','s'],
        'u': ['u','u'],
        'code': ['code','code'], 
        'size': ['size\s*(?:=\s*(?:"([^"]+)")|=\s*([^"]+))?', 'size'],
        'quote': ['quote\s*(?:=\s*(?:"([^"]+)")|=\s*([^"]+))?','quote'],
        'url': ['url\s*(?:=\s*(?:"([^"]+)")|=\s*([^"]+))?', 'url'],
        'img': ['img', 'img'],
    }

# The tags are supossed to fall under this regexp
regexp_tag = re.compile("(\[.*?\])")

for key, value in tags.iteritems():
    tags[key] = [ re.compile("\[\s*%s\s*\]" % value[0]), re.compile("\[\s*/\s*%s\\s*]"% value[1]) if value[1] else None ]

def parse(text, context = None):
    before = []
    control = True
    
    while control:
        ret = regexp_tag.split(text,1)
        tag = None
        args = []
        after = None
        if len(ret) != 3: # Don't have a tag
            before.append(text)
            break

        before.append(ret[0])
        tag = ret[1]
        after = "".join(i if i else "" for i in ret[2:])
        args = None

        for key,value in tags.iteritems():
            if value[0].match(tag):
                args =  value[0].match(tag).groups()
                if len(args) > 0:
                    if args[0]:
                        args = [args[0]]
                    elif args[1]:
                        args = [args[1]]
                    else:
                        args = []
                tag = ('BBCODE', True, key, len(args))
                control = False
                break
            elif value[1] and value[1].match(tag):
                tag = ('BBCODE', False, key, 0)
                control = False
                break
        if control:
            before.append(tag)
            text = after

    str = "".join(before)
    pos = len(str)

    return pos, str, tag, args, after
