# $Id: parser_html.py 472 2007-11-08 22:55:21Z alvaro $

# FIXME: Allow multiple attributes
allowed_html = {
    "a": "href", 
    "p": None, 
    "b": None, 
    "s": None, 
    "i": None, 
    "code": None, 
    "em": None, 
    "strong": None, 
    "img": ["src", "alt"],
}

from sgmllib import SGMLParser, SGMLParseError
class HTMLParser(SGMLParser):
  def __init__(self, context = None):
    self._context = context
    SGMLParser.__init__(self)
    self.reset()

  def reset(self):                       
    self._parsed = 0
    self._before = []
    self._tag = None
    self._args = None
    self._after = []
    SGMLParser.reset(self)

  def do_img(self, attrs):
    if not attrs: raise SGMLParseError, "Error, argumentos para <img> no validos"
    self.setnomoretags()
    self._parsed += 1
    import cgi
    if "src" not in [i[0] for i in attrs]:
      raise SGMLParseError, "Error, faltan atributos para el tag 'img'"
    args = " ".join(['%s="%s"' % i for i in attrs if i[0] in allowed_html['img']])
    args = cgi.escape(args)
    self._tag = ('TEXT','<img %s />' % args)

  def end_img(self):
    pass

  def do_br(self):
    self.setnomoretags()
    self._parsed += 1
    import cgi
    self._tag = ('TEXT','<br />' % args)

  def end_br(self):
    pass

  def unknown_starttag(self, tag, attrs):
    if tag in allowed_html.keys():
      if tag=="a" and self._context == "a":
        raise SGMLParseError, "Error, tag <%s> no permitido dentro de <%s>" % (tag, self._context)
      self.setnomoretags()
      self._parsed += 1
      self._args = ['%s' % i[1] for i in attrs if i[0] in allowed_html[tag]]
      self._tag = ("HTML", True, tag, len(self._args))
      if len(self._args) == 0 and allowed_html[tag]:
        raise SGMLParseError, "Error, faltan atributos para el tag '%s'" % tag
    else:
      self._before.append("".join(["<",tag,">"]))

  def unknown_endtag(self, tag):         
    if tag in allowed_html.keys():
      self.setnomoretags()
      self._parsed += 1
      self._tag = ("HTML", False, tag, 0)
    else:
      self._before.append("".join(["<",tag,">"]))

  def handle_data(self, text):           
    if self._parsed > 0:
      self._after.append(text)
    else:
      self._before.append(text)

  def get_tuple(self):
    self._before = "".join(self._before)
    pos = len(self._before)
    return pos, "".join(self._before), self._tag, self._args, "".join(self._after)

def parse(text, context = None):
  parser = HTMLParser(context = None)
  parser.reset()
  try:
    parser.feed(text)
  except SGMLParseError, e:
    pass
    return -1, e.message or "HTML no valido"
  return parser.get_tuple()
