# $Id: url_LOGIN_OpenID.py 191 2007-06-26 22:19:05Z jcea $

from globales import monitor,openid_support

if openid_support :
  from openid.store import memstore
  import sys
  sessions=memstore.MemoryStore()
  state={}
  expire_state=[]
  import threading
  mutex=threading.Lock()

def create_new_state(usuario,path) :
  import sys,random,time
  global state,expire_state,mutex
  ts=time.time()
  mutex.acquire()
  try :
    if len(expire_state)>256 : # Numero maximo de sesiones simultaneas
      del state[expire_state.pop(0)[1]]
    rnd=random.randint(0,sys.maxint)
    while rnd in state :
      rnd=random.randint(0,sys.maxint)
    expiracion=ts+15*60
    st={"expiracion":expiracion,"usuario":usuario,"path":path}
    state[rnd]=st
    expire_state.append((expiracion,rnd))
    while expire_state[0][0]<ts : 
      del state[expire_state.pop(0)[1]]
    return (rnd,st)
  finally :
    mutex.release()

def pop_state(st) :
  global state,expire_state,mutex
  import bisect
  mutex.acquire()
  try :
    v=state.get(st)
    if v :
      del state[st]
      expire_state.pop(bisect.bisect_left(expire_state,v["expiracion"])) # Esto no deberia fallar nunca...
    return v
  finally :
    mutex.release()


def gestiona_url(handler,path,usuario) :
  global sessions

  if not openid_support : return None
  if len(path)!=2 : return None

  try :
    st=int(path[1])
  except :
    return None

  st=pop_state(st)
  if not st :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},"Peticion invalida")

  q=handler.path.find("?")
  if q<0 : return (200,{"Content-Type":"text/plain; charset=utf-8"},"Peticion invalida")

  try :
    import urlparse,cgi
    q={}
    for k, v in cgi.parse_qsl(urlparse.urlparse(handler.path)[4]) :
      q[k] = v.decode('utf-8')
  except :
    raise

  from openid.consumer import consumer
  oidconsumer=consumer.Consumer(st,sessions)
  info=oidconsumer.complete(q)

  if info.status==consumer.FAILURE and info.identity_url :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},"Verificacion fallida")
  elif info.status==consumer.SUCCESS :
    @monitor
    def login(conn,usuario) :
      import database
      return database.usuario_verifica(conn,nick=usuario,force_login=True)
    resultado=login(st["usuario"])
    assert resultado
    nick,cookie=resultado
    if cookie :
      cookie="cpif_auth=%s; path=/;  expires=Wed, 01-Jan-2030 00:00:00 GMT;" %cookie
    return (302,{"Set-Cookie":cookie,"Location":st["path"]},"")
  elif info.status==consumer.CANCEL :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},"Verificacion Cancelada")
  elif info.status==consumer.SETUP_NEEDED :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},"Falta configuracion")
  else :
    return (200,{"Content-Type":"text/plain; charset=utf-8"},"Error desconocido")

