# $Id: url_indice.py 366 2007-09-13 13:33:10Z jcea $

from globales import monitor

import globales

import datetime
delta_dia=datetime.timedelta(1)
medianoche=datetime.time(0)

# La fecha del hilo modificado hace mas tiempo
fecha_min=None

@monitor
def gestiona_url(conn,handler,path,usuario) :
  import time,database,datetime,calendar
  global delta_dia

  l=len(path)
  if l<2 or l>3 : return None

  first_page=True
  fecha=datetime.date.today()
  try :
    metatag=int(path[1])
  except :
    return None

  if not database.user_has_metatag_access(conn,usuario,metatag) :
    return None

  if l==3 :
    try :
      fecha_max=fecha
      fecha=path[2]
      assert len(fecha) == 8
      fecha=datetime.date(int(fecha[:4]),int(fecha[4:6]),int(fecha[6:8]))
      if fecha>fecha_max : return None
      if fecha<fecha_min : return None
      if fecha!=fecha_max : first_page=False
    except :
      return None

  fecha_elegida=fecha
  fecha_max=fecha+delta_dia # Empezamos a listar los hilos escritos desde las 0:00 de "man~ana"

  tz=database.usuario_get_tz(conn,usuario)  # Also valid if anonymous

  def timegm(fecha) :
    dt=tz.localize(datetime.datetime.combine(fecha,medianoche))
    return calendar.timegm(dt.utctimetuple())
  ts=timegm(fecha_max)

  import skins
  pagina = skins.Skin(path,usuario,handler.headers)
  import calendario
  d = {
      "page_title": "cpif - listado de hilos",
      "threads":[],
      "stickies":[],
      "calendar": calendario.vista_mensual(conn,fecha_elegida,usuario,metatag),
      "metatag": metatag,
      "monitor": database.monitored_metatag(conn,usuario,metatag),
      "user": usuario,
      "tz": tz,
      }

  root=conn.get_root()
  hilos=root["hilos"]["hilos"]
  database.actualiza_no_leidos(conn,usuario)
  texto=[]
  num_hilos=0
  punto_no_leido=root["usuarios"]["usuarios"][database.normaliza_nick(usuario)]["punto de lectura no leidos"][metatag]

  d["metatag_title"] = root["metatags"]["metatags"][metatag]["nombre"]

  if first_page:
    h=database.listado_stickies_personal(conn,usuario,metatag=metatag)
    if len(h) : # if we touch this data schema, we must update the "normal thread" one too.
      d["stickies"].append((ts, [(
        id,
        title,
        hilos[id]["TS"],
        hilos[id]["mensajes"].get(punto_no_leido.get(id,None)), # El numero de mensajes hasta el no leido
        punto_no_leido.get(id,None), # El punto donde el usuario no ha leido
        hilos[id]["num_mensajes"],
        mon,
        ro) for id,title,not_read,mon,ro in h]))
  
  while (num_hilos<50) and (fecha>=fecha_min) :
    ts2=timegm(fecha)
    h=database.listado_hilos_personal(conn,usuario,ts,ts2,metatag=metatag)
    l=len(h)
    if l : # if we touch this data schema, we must update the "sticky" one too.
      d["threads"].append((ts2,[(
        id, 
        title,
        hilos[id]["TS"], 
        hilos[id]["mensajes"].get(punto_no_leido.get(id,None)), # El numero de mensajes hasta el no leido
        punto_no_leido.get(id,None), # El punto donde el usuario no ha leido
        hilos[id]["num_mensajes"],
        mon,
        ro) for id,title,not_read,mon,ro in h])) 

      num_hilos+=l
    ts=ts2
    fecha-=delta_dia

  pagina.load_dict(d)
  return(pagina.web())

@monitor
def init(conn) :
  import datetime,sys,time
  global fecha_min

  fecha_min=time.time()
  root=conn.get_root()
  for metatag in root["metatags"]["metatags"].itervalues() :
    mt=metatag["TS2hilo"]
    if mt :
      fecha_min=min(fecha_min,mt.get_min_item()[0])

  fecha_min=datetime.date.fromtimestamp(fecha_min)

