# $Id: url_new_user_confirmation.py 363 2007-09-13 11:41:52Z jcea $

from globales import monitor
from globales import user_sign_in_mode

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=2 : return None
  nonce=path[1]

  import skins
  pagina = skins.Skin(path,usuario)
  pagina.load_dict({"page_title": "cpif - Alta exitosa"})
  
  import database
  v=database.get_usuario_pending(conn,nonce)

  if not v :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>URL incorrecta. Si ya ha confirmado su alta, no necesita volver a hacerlo.</h1>"})
    return (pagina.web())

  nick,datos,clave,email,OpenIDs=v

  if database.usuario_verifica(conn,nick=nick) :
    pagina.load_url(["error"])
    pagina.load_dict({"generic_message": "<h1>El usuario ya existe</h1>"})
    return (pagina.web())

  database.usuario_add(conn,nick,None,clave=clave,email=email,OpenIDs=OpenIDs)
  if user_sign_in_mode==1 :
    database.set_usuario_no_login(conn,nick) # We need the master aproval

    from globales import smtp_email_sender,base_url,admin_email_address
    texto=["From: %s" %smtp_email_sender]
    texto.append("To: %s" %admin_email_address)
    texto.append("Subject: Confirmacion de alta de usuario")
    texto.append("")
    texto.append("Un usuario ha confirmado el alta, pero se requiere")
    texto.append("tambien la confirmacion del administrador.")
    texto.append("")
    texto.append("Como administrador, puede ver el perfil del usuario")
    texto.append("pulsando sobre el siguiente enlace:")
    texto.append("")
    texto.append("%s/perfil/%s" %(base_url,nick))

    import smtp
    smtp.enqueue(conn,[admin_email_address],"\r\n".join(texto))

    pagina.load_dict({"generic_message": "<h1>Alta exitosa, pero se requiere la confirmacion del administrador. Recibir&aacute; un mensaje de correo electr&oacute;nico con la decisi&oacute;n.</h1>"})
    return (pagina.web())

  resultado=database.usuario_verifica(conn,nick=nick,force_login=True)
  assert resultado
  nick,cookie=resultado
  if cookie :
    cookie="cpif_auth=%s; path=/;  expires=Wed, 01-Jan-2030 00:00:00 GMT;" %cookie
  return (302,{"Set-Cookie":cookie,"Location":"/"},"")

