# $Id: url_static.py 295 2007-07-27 00:48:58Z jcea $

from globales import monitor

@monitor
def gestiona_url(conn,handler,path,usuario) :
  if len(path)!=3 : return None
  section,hash=path[1],path[2]
  etag='"%s"' %hash
  headers={"ETag":etag,"Cache-Control":"max-age=31536000"}

  import database
  data=database.get_static(conn,section,hash)
  if not data : return None # Not found

  metadata,data=data
  data=data[0] # de-encapsulate
  last_modified=metadata["last modified"]
  headers["Last-Modified"]=last_modified

  if_none_match=handler.headers.get("if-none-match")
  if if_none_match :
    for i in if_none_match.split(",") :
      if etag==i.strip() :
        return (304,headers,"")

# Actually, all static objects have an ETag, and that should
# be used to check object freshness. We implement "If-Modified-Since"
# to please tools like "wget" or the cacheability tool at
# http://www.mnot.net/cacheability/
  if_modified_since=handler.headers.get("if-modified-since")
  if if_modified_since==last_modified : # TODO: Actually parse the header, do not do a simple string comparison
    return (304,headers,"")

  headers["Content-Type"]=metadata["content-type"]

  return (200,headers,data)

