# $Id: __init__.py 266 2007-07-11 21:19:25Z heimy $

import os
from nodes import TextNode, NodeList, MatchObject

skip_list = ['__init__.py', 'token.py']
grammar_list = []

class DummyGrammar(object):
    def search(self, strng):
        return MatchObject(self, strng, 0, len(strng) + 1)
    def get_nodes(self, parser, strng):
        return TextNode(strng)

dummy_grammar = DummyGrammar()

def get_matches(strng):
    global grammar_list, dummy_grammar

    matches = [x for x in (y.search(strng) for y in grammar_list) if not x.is_nil()]
    if not matches:
        matches = [dummy_grammar.search(strng)]

    return matches

valid_grammar_mod = lambda x: x.endswith('.py') and x not in skip_list
this_dir = os.path.dirname(__file__)

for grmr in (x for x in os.listdir(this_dir) if valid_grammar_mod(x)):
    try:
        name = grmr[:-3]
        mdl = __import__(name, globals(), (), name)
        cls = getattr(mdl, 'Grammar', None)
        if cls:
            grammar_list.append(cls())
    except ImportError:
        pass

__all__ = ["get_matches"]
