# $Id: bbcode.py 266 2007-07-11 21:19:25Z heimy $

import re
from nodes import NodeList, MatchObject

class AnchorNode(NodeList):
    def __init__(self, parser, uri, text):
        self.uri = uri
        self.extend(parser.parse(text))
    def render_html(self):
        return "<a href='%s'>%s</a>" % (self.uri, super(AnchorNode, self).render_html())

class BoldNode(NodeList):
    def __init__(self, parser, text):
        self.extend(parser.parse(text))
    def render_html(self):
        return "<b>%s</b>" % super(BoldNode, self).render_html()

express = {
    'url':  (AnchorNode, re.compile('''\[url="([^"]*?)"\](.*?)\[/url\]''')),
    'bold': (BoldNode, re.compile('''\[b\](.*?)\[/b\]''')),
    }

class Grammar(object):
    def search(self, strng):
        lst = []
        for (key, (nodecls, regexp)) in express.items():
            ret = regexp.search(strng)
            if ret:
                lst.append(MatchObject(self, (nodecls, ret), *ret.span()))
        if not lst:
            lst = [MatchObject(self, None, 0, 0)]

        return sorted(lst)[0]
    def get_nodes(self, parser, info):
        nodecls, ret = info
        return nodecls(parser, *ret.groups())
