# $Id: nodes.py 266 2007-07-11 21:19:25Z heimy $

class Node(object):
    def render_html(self):
        return ""

class TextNode(Node):
    def __init__(self, content):
        self.content = content

    def render_html(self):
        return self.content

class MatchObject(object):
    def __init__(self, grammar, info, beg, end):
        self.grammar = grammar
        self.info = info
        self.beg, self.end = beg, end
    def __cmp__(self, other):
        return cmp( (self.beg, self.end), (other.beg, other.end) )
    def is_nil(self):
        if self.beg == self.end:
            return True
        return False
    def get_nodes(self, parser):
        return self.grammar.get_nodes(parser, self.info)

class NodeList(list, Node):
    def render_html(self):
        return ''.join([x.render_html() for x in self])
